struct lista {
   long time;
   struct lista *anterior;
   struct lista *siguiente;
};

struct lista *crearLista() {
   return NULL;
}

struct lista *crearNodo(long time) {
   struct lista *n;

   n = (struct lista *)malloc(sizeof(struct lista));
   n->time = time;
   return n;
}

struct lista *insertaNodo(struct lista *p, long time) {
   struct lista *n, *t;

   n = crearNodo(time);

   if(p==NULL) {
      n->anterior = NULL;
      n->siguiente = NULL;
      p = n;
   }
   else if(p->time > time) {
      p->anterior = n;
      n->siguiente = p;
      n->anterior = NULL;
      p = n;
   }
   else {
      t = p;
      while((t->siguiente) != NULL) {
         t = t->siguiente;
         if(t->time == time) break;
         if(t->time > time) {
            n->anterior = t->anterior;
            (t->anterior)->siguiente = n;
            t->anterior = n;
            n->siguiente = t;
            break;
         }
      }
      if((t->time < time) && (t->siguiente==NULL)) {
         t->siguiente = n;
         n->anterior = t;
         n->siguiente = NULL;
      }
   }
   return p;
}

struct lista *buscaNodo(struct lista *p, long time) {
   while(p!=NULL) {
      if(p->time == time)
         break;
      p = p->siguiente;
   }
   return p;
}

struct lista *buscaNodoumbrales(struct lista *p, long timedown, long timeup) {
   while(p!=NULL) {
      if(p->time > timedown && p->time <= timeup)
         break;
      p = p->siguiente;
   }
   return p;
}

struct lista *buscaNodosiguiente(struct lista *p, long time) {
   while(p!=NULL) {
      if(p->time >= time)
         break;
      p = p->siguiente;
   }
   return p;
}

struct lista *buscaNodoanterior(struct lista *p, long time) {
   struct lista *t;

   t = p;
   p = p->siguiente;
   if(t->time <= time && t->siguiente == NULL) return t;
   if(t->time > time) return NULL;
   while(t->siguiente != NULL) {
      if(t->time <= time && p->time > time)
         return t;
      p = p->siguiente;
      t = t->siguiente;
   }
   return t;
}

struct lista *eliminaNodo(struct lista *p, long time) {
   struct lista *t;

   t = p;
   while(t!=NULL) {
      if(t->time == time)
         break;
      t = t->siguiente;
   }
   if(t!=NULL) {
      if(t->anterior == NULL && t->siguiente == NULL) {
         free((void *)t);
         p = NULL;
      }
      else if(t->anterior == NULL) {
         p = t->siguiente;
         p->anterior = NULL;
         free((void *)t);
      }
      else if(t->siguiente == NULL) {
         (t->anterior)->siguiente = NULL;
         free((void *)t);
      }
      else {
         (t->anterior)->siguiente = t->siguiente;
         (t->siguiente)->anterior = t->anterior;
         free((void *)t);
      }
   }
   return p;
}

void borrarLista(struct lista *p) {
   struct lista *t;
   while(p!=NULL) {
      t = p;
      p = p->siguiente;
      free((void *)t);
   }
}
